'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.date = exports.math = exports.sort = exports.regexp = exports.DataGrid = exports.Gesture = exports.Grid = exports.Pagination = exports.responsive = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _browsers = require('./utils/browsers');

Object.keys(_browsers).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _browsers[key];
    }
  });
});

var _common = require('./utils/common');

Object.keys(_common).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _common[key];
    }
  });
});

var _page = require('./utils/page');

Object.keys(_page).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _page[key];
    }
  });
});

var _delayOperate = require('./utils/delayOperate');

Object.keys(_delayOperate).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _delayOperate[key];
    }
  });
});

var _domEvent = require('./utils/domEvent');

Object.keys(_domEvent).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _domEvent[key];
    }
  });
});

var _grid = require('./components/grid');

Object.keys(_grid).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _grid[key];
    }
  });
});

var _core = require('./core');

var _core2 = _interopRequireDefault(_core);

var _config = require('./config');

var _config2 = _interopRequireDefault(_config);

var _regexp = require('./utils/regexp');

var regexp = _interopRequireWildcard(_regexp);

var _sort = require('./utils/sort');

var sort = _interopRequireWildcard(_sort);

var _math = require('./utils/math');

var math = _interopRequireWildcard(_math);

var _date = require('./utils/date');

var date = _interopRequireWildcard(_date);

var _responsive = require('./higherOrders/responsive');

var _responsive2 = _interopRequireDefault(_responsive);

var _pagination = require('./components/pagination');

var _pagination2 = _interopRequireDefault(_pagination);

var _grid2 = _interopRequireDefault(_grid);

var _gesture = require('./components/gesture');

var _gesture2 = _interopRequireDefault(_gesture);

var _dataGrid = require('./components/dataGrid');

var _dataGrid2 = _interopRequireDefault(_dataGrid);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

_extends(_core2.default, {
  config: _config2.default,
  responsive: _responsive2.default,
  Pagination: _pagination2.default,
  Grid: _grid2.default,
  Gesture: _gesture2.default,
  DataGrid: _dataGrid2.default
});

var _global = typeof self !== 'undefined' ? self : global;
_global.FlareJ = _global.fj = _core2.default;

exports.responsive = _responsive2.default;
exports.Pagination = _pagination2.default;
exports.Grid = _grid2.default;
exports.Gesture = _gesture2.default;
exports.DataGrid = _dataGrid2.default;
exports.regexp = regexp;
exports.sort = sort;
exports.math = math;
exports.date = date;
exports.default = _core2.default;