'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _merge = require('lodash/merge');

var _merge2 = _interopRequireDefault(_merge);

var _sizeSensor = require('size-sensor');

var _ecConfig = require('../../utils/ecConfig');

require('../../styles/echarts');

require('../grid');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/* babel-plugin-nornj-loader './ECharts.t.html' */var template = {
  chart: nj.compileH({
  _njTmplKey: 81370253,
  useString: false,
  main: function anonymous(g,c,p
) {

var _type0 = g.e('div', g, 'div', c);
var _params0 = {
  'className': (g.f['.'](c.d('props'), 'className')),
  'style': g.sp((g.f['.'](c.d('props'), 'style')))
};
var _compParam0 = [_type0, _params0];

var _type1 = g.e('fj-row', g, 'fj-row', c);
var _params1 = {
  'className': 'fj-area-chart-panel',
  'ref': (c.d('chart'))
};
var _compParam1 = [_type1, _params1];

_compParam0.push(g.H(_compParam1));

return g.H(_compParam0);
}
}),
  enhance: nj.compileH({
  _njTmplKey: 278189827,
  useString: false,
  main: function anonymous(g,c,p
) {

var _type0 = g.er((c.d('ComposedComponent')), 'composedcomponent', g, 'ComposedComponent', c);
var _params0 = {
  'ref': (c.d('ref')),
  'className': (c.d('classes')),
  'style': g.sp((c.d('styles'))),
  'update': (c.d('update')),
  'chartInstance': (c.d('chartInstance'))
};

var _ex0 = g.x['spread'];
var _dataRefer0 = [
  (c.d('props')),{ _njOpts: 1, useString: false, tagName: _type0, setTagName: function(c) { _type0 = c }, tagProps: _params0, value: g.np }
];

_ex0.apply(c, _dataRefer0);
var _compParam0 = [_type0, _params0];

return g.H(_compParam0);
}
})
};


var EChartsEnhance = function EChartsEnhance(ComposedComponent) {
  var _class, _temp;

  return _temp = _class = function (_Component) {
    _inherits(EcComponent, _Component);

    function EcComponent(props) {
      _classCallCheck(this, EcComponent);

      var _this = _possibleConstructorReturn(this, _Component.call(this, props));

      _this.component = null;
      return _this;
    }

    EcComponent.prototype.getWrap = function getWrap() {
      var current = this.component.chart.current;
      return current.wrap || current.wrappedInstance && current.wrappedInstance.wrap || current.parentNode;
    };

    EcComponent.prototype.createOption = function createOption() {
      var _props = this.props,
          option = _props.option,
          title = _props.title,
          subTitle = _props.subTitle;

      return (0, _merge2.default)((0, _ecConfig.initOption)(this.component.props.type, title, subTitle), option);
    };

    EcComponent.prototype.createChart = function createChart() {
      this.chartOption = this.createOption();
      this.chart = (0, _ecConfig.createChart)(this.getWrap(), this.props.data, this.chartOption, this.props.expandOption, this.props.theme);
    };

    EcComponent.prototype.componentDidMount = function componentDidMount() {
      var _this2 = this;

      this.createChart();

      var _props2 = this.props,
          onChartReady = _props2.onChartReady,
          autoResize = _props2.autoResize;

      var wrap = this.getWrap();
      if (autoResize && wrap) {
        (0, _sizeSensor.bind)(wrap, function () {
          _this2.chart.resize();
        });
      }

      onChartReady && onChartReady(this.chart);
    };

    EcComponent.prototype.componentDidUpdate = function componentDidUpdate() {
      var update = this.props.update;

      if (!update) {
        return;
      }

      var _props3 = this.props,
          data = _props3.data,
          option = _props3.option,
          title = _props3.title,
          subTitle = _props3.subTitle,
          showLoading = _props3.showLoading,
          loadingOption = _props3.loadingOption;


      (0, _ecConfig.updateChart)(this.chart, data, _extends({}, this.chartOption, (0, _merge2.default)({
        title: {
          text: title,
          subtext: subTitle
        },
        tooltip: {
          trigger: 'axis'
        }
      }, option)));

      if (showLoading) {
        this.chart.showLoading(loadingOption);
      } else {
        this.chart.hideLoading();
      }
    };

    EcComponent.prototype.componentWillUnmount = function componentWillUnmount() {
      var wrap = this.getWrap();
      if (wrap) {
        var autoResize = this.props.autoResize;

        if (autoResize) {
          try {
            (0, _sizeSensor.clear)(wrap);
          } catch (ex) {
            console.warn(ex);
          }
        }

        this.chart && this.chart.dispose(wrap);
      }
    };

    EcComponent.prototype.render = function render() {
      var _this3 = this;

      var _props4 = this.props,
          className = _props4.className,
          style = _props4.style,
          width = _props4.width,
          height = _props4.height,
          others = _objectWithoutProperties(_props4, ['className', 'style', 'width', 'height']);

      var classes = (0, _classnames2.default)(_defineProperty({
        'fj-area-chart-area': true
      }, className, className));

      var styles = {};
      if (width != null) {
        styles.width = width;
      }
      if (height != null) {
        styles.height = height;
      }
      if (style) {
        _extends(styles, style);
      }

      return template.enhance(this.state, {
        ComposedComponent: ComposedComponent,
        ref: function ref(c) {
          return _this3.component = c;
        },
        classes: classes,
        styles: styles,
        props: others,
        chartInstance: this.chart
      });
    };

    return EcComponent;
  }(_react.Component), _class.propTypes = {
    update: _propTypes2.default.bool,
    name: _propTypes2.default.string,
    option: _propTypes2.default.object,
    data: _propTypes2.default.array,
    title: _propTypes2.default.string,
    subTitle: _propTypes2.default.string,
    expandOption: _propTypes2.default.object,
    theme: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.object]),
    showLoading: _propTypes2.default.bool,
    loadingOption: _propTypes2.default.object,
    onChartReady: _propTypes2.default.func,
    autoResize: _propTypes2.default.bool
  }, _class.defaultProps = {
    update: true,
    showLoading: false,
    autoResize: true
  }, _temp;
};

exports.default = EChartsEnhance;