'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = function (ComposedComponent, initialProps) {
  var _class, _temp;

  return _temp = _class = function (_Component) {
    _inherits(Responsive, _Component);

    function Responsive(props) {
      _classCallCheck(this, Responsive);

      var _this = _possibleConstructorReturn(this, _Component.call(this, props));

      _this.state = {};

      if (props.compType == null) {
        _this.compType = (0, _common.guid)();
      }

      //Initialize
      _this.bindResponsiveEvts();
      return _this;
    }

    //绑定响应式事件


    Responsive.prototype.bindResponsiveEvts = function bindResponsiveEvts() {
      var _this2 = this;

      var props = this.props;
      if (!props.responsive) {
        return;
      }

      //页面尺寸改变时触发响应式处理
      var fn = this.responsiveResize = function () {
        (0, _delayOperate.lazyDo)(function () {
          var isRh = true;

          //只有在页面宽度改变时执行响应式处理
          if (props.responsiveOnlyWidth) {
            var w = (0, _page.pageWidth)();

            //页面宽度和上一次不同
            if (w !== _this2.globalWidth) {
              _this2.globalWidth = w;
              isRh = true;
            } else {
              isRh = false;
            }
          }

          if (isRh) {
            //响应式处理
            _this2.responsiveHandle();
          }
        }, props.responsiveDelay, 'ld_' + (props.compType != null ? props.compType : _this2.compType) + '_responsive', _this2);
      };

      (0, _domEvent.on)('resize', fn, win);

      //初始化时执行一次响应式处理
      this.responsiveHandle(true);
    };

    //响应式处理


    Responsive.prototype.responsiveHandle = function responsiveHandle(isInit) {
      var _this3 = this;

      var props = this.props;
      var newState = this.state,
          handlers = [];

      //处理响应参数
      [props.defaultResponsiveParam, props.responsiveParam].forEach(function (responsiveParam) {
        _nornj2.default.each(responsiveParam, function (rpp, media) {
          if ((0, _page.mediaQuery)(media)) {
            //符合条件时执行响应式处理
            if (rpp.state) {
              //设置响应状态值
              newState = (0, _reactAddonsUpdate2.default)(newState, { $merge: rpp.state });
            }

            if (rpp.preHandler) {
              //响应前操作
              var ret = rpp.preHandler.call(_this3, isInit, (0, _reactAddonsUpdate2.default)(newState, { $merge: {} }));
              if (ret) {
                newState = ret;
              }
            }

            if (rpp.handler) {
              //响应后操作
              handlers[handlers.length] = {
                handler: rpp.handler,
                delay: rpp.delay
              };
            }
          }
        }, null, false);
      });

      //执行响应后操作
      var runHandlers = function runHandlers() {
        _nornj2.default.each(handlers, function (h) {
          var fnH = function fnH() {
            h.handler.call(_this3, isInit);
          };

          if (h.delay) {
            //可延迟执行时间
            (0, _delayOperate.lazyDo)(function () {
              fnH();
            }, h.delay);
          } else {
            fnH();
          }
        }, null, true);
      };

      //重置state
      if (isInit) {
        //在初始化时需要重新设置state
        this.state = newState;
        runHandlers();
      } else {
        //非初始化时执行setState
        this.setState(newState, function () {
          return runHandlers();
        });
      }
    };

    Responsive.prototype.componentWillUnmount = function componentWillUnmount() {
      var responsiveResize = this.responsiveResize;

      //移除响应式事件
      if (responsiveResize) {
        (0, _domEvent.off)('resize', responsiveResize, win);
      }
    };

    Responsive.prototype.render = function render() {
      var _this4 = this;

      return tmpls.responsive({
        ComposedComponent: ComposedComponent,
        ref: function ref(c) {
          return _this4.component = c;
        }
      }, this);
    };

    return Responsive;
  }(_react.Component), _class.propTypes = {
    responsive: _propTypes2.default.bool,
    responsiveDelay: _propTypes2.default.number,
    responsiveOnlyWidth: _propTypes2.default.bool,
    responsiveParam: _propTypes2.default.object,
    defaultResponsiveParam: _propTypes2.default.object
  }, _class.defaultProps = _extends({
    responsive: false,
    responsiveDelay: 70,
    responsiveOnlyWidth: true
  }, initialProps), _temp;
};

var _react = require('react');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactAddonsUpdate = require('react-addons-update');

var _reactAddonsUpdate2 = _interopRequireDefault(_reactAddonsUpdate);

var _nornj = require('nornj');

var _nornj2 = _interopRequireDefault(_nornj);

var _common = require('../utils/common');

var _delayOperate = require('../utils/delayOperate');

var _page = require('../utils/page');

var _domEvent = require('../utils/domEvent');

require('../njHelpers');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/* babel-plugin-nornj-loader './higherOrders.t.html' */var tmpls = {
  responsive: _nornj2.default.compileH({
  _njTmplKey: 1248492026,
  useString: false,
  main: function anonymous(g,c,p
) {

var _type0 = g.er((c.d('ComposedComponent')), 'composedcomponent', g, 'ComposedComponent', c);
var _params0 = {
  'ref': (c.d('ref'))
};

var _ex0 = g.x['spread'];
var _dataRefer0 = [
  (c.d('props')),{ _njOpts: 1, useString: false, tagName: _type0, setTagName: function(c) { _type0 = c }, tagProps: _params0, value: g.np }
];

_ex0.apply(c, _dataRefer0);

var _ex1 = g.x['spread'];
var _dataRefer1 = [
  (c.d('state')),{ _njOpts: 1, useString: false, tagName: _type0, setTagName: function(c) { _type0 = c }, tagProps: _params0, value: g.np }
];

_ex1.apply(c, _dataRefer1);
var _compParam0 = [_type0, _params0];

return g.H(_compParam0);
}
})
};

var win = window;