'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isWebkit = exports.isMobile = exports.isWindowsPhone = exports.isIos = exports.isIpod = exports.isIpad = exports.isIphone = exports.isAndroid = exports.isOpera = exports.isSafari = exports.isChrome = exports.isFirefox = exports.isIEgt9 = exports.isIEgt10 = exports.isIElt11 = exports.isIElt9 = exports.isIE11 = exports.isIE10 = exports.isIE9 = exports.isIE = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _core = require('../core');

var _core2 = _interopRequireDefault(_core);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _docMode = document.documentMode,
    _ua = navigator.userAgent.toLowerCase();

var _browser = {
  version: (_ua.match(/.+(?:rv|it|ra|ie)[\/: ]([\d.]+)/) || [0, '0'])[1],
  opera: /opera/i.test(_ua),
  firefox: /firefox/i.test(_ua),
  ie: /msie/i.test(_ua) && !/opera/.test(_ua),
  chrome: /chrome/i.test(_ua) && /webkit/i.test(_ua) && /mozilla/i.test(_ua),
  android: _ua.indexOf('android') > -1,
  iphone: _ua.indexOf('iphone') > -1,
  ipad: _ua.indexOf('ipad') > -1,
  ipod: _ua.indexOf('ipod') > -1,
  windowsPhone: _ua.indexOf('windows phone') > -1
};
_browser.safari = /webkit/i.test(_ua) && !_browser.chrome;
_browser.mozilla = /mozilla/i.test(_ua) && !/(compatible|webkit)/.test(_ua) && !_browser.chrome;

//IE
var isIE = exports.isIE = _browser.ie || !!window.ActiveXObject || "ActiveXObject" in window;

//IE9
var isIE9 = exports.isIE9 = isIE && _browser.version == 9.0 && (!_docMode || _docMode == 9) || _docMode == 9;

//IE10
var isIE10 = exports.isIE10 = isIE && _browser.version == 10.0 && (!_docMode || _docMode == 10) || _docMode == 10;

//IE11
var isIE11 = exports.isIE11 = isIE && _browser.version == 11.0 && (!_docMode || _docMode == 11) || _docMode == 11;

//IE version less than 9
var isIElt9 = exports.isIElt9 = isIE && !isIE9 && !isIE10 && !isIE11;

//IE version less than 11
var isIElt11 = exports.isIElt11 = isIE9 || isIE10;

//IE version more than 10
var isIEgt10 = exports.isIEgt10 = isIE10 || isIE11;

//IE version more than 9
var isIEgt9 = exports.isIEgt9 = isIE9 || isIEgt10;

//FireFox
var isFirefox = exports.isFirefox = _browser.mozilla;

//Chrome
var isChrome = exports.isChrome = _browser.chrome;

//Safari
var isSafari = exports.isSafari = _browser.safari;

//Opera
var isOpera = exports.isOpera = _browser.opera;

//Android
var isAndroid = exports.isAndroid = _browser.android;

//Iphone
var isIphone = exports.isIphone = _browser.iphone;

//Ipad
var isIpad = exports.isIpad = _browser.ipad;

//Ipod
var isIpod = exports.isIpod = _browser.ipod;

//Ios
var isIos = exports.isIos = isIphone || isIpad || isIpod;

//Windows Phone
var isWindowsPhone = exports.isWindowsPhone = _browser.windowsPhone;

//Mobile browser
var isMobile = exports.isMobile = isAndroid || isIos || isWindowsPhone;

//Webkit and blink core browser
var isWebkit = exports.isWebkit = isChrome || isSafari || isAndroid || isIos;

_extends(_core2.default, {
  isIE: isIE,
  isIE9: isIE9,
  isIE10: isIE10,
  isIE11: isIE11,
  isIElt9: isIElt9,
  isIElt11: isIElt11,
  isIEgt10: isIEgt10,
  isIEgt9: isIEgt9,
  isFirefox: isFirefox,
  isChrome: isChrome,
  isSafari: isSafari,
  isOpera: isOpera,
  isAndroid: isAndroid,
  isIphone: isIphone,
  isIpad: isIpad,
  isIpod: isIpod,
  isIos: isIos,
  isWindowsPhone: isWindowsPhone,
  isMobile: isMobile,
  isWebkit: isWebkit
});