'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.handleErrors = handleErrors;
exports.setDefaultOptions = setDefaultOptions;
exports.fetchData = fetchData;

var _querystring = require('querystring');

var _querystring2 = _interopRequireDefault(_querystring);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function handleErrors(response) {
  if (!response.ok) {
    throw Error(response.statusText);
  }
  return response;
}

var _defaultOptions = { useApplicationJson: true };
function setDefaultOptions() {
  var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  return _extends(_defaultOptions, options);
}

function fetchData(url, callback, params, cfgs) {
  var configs = _extends({
    method: 'get',
    credentials: 'include',
    mode: 'cors',
    cache: 'reload'
  }, _defaultOptions, cfgs);

  configs.method = configs.method.toLowerCase();
  if (params) {
    if (configs.method === 'get' || configs.method === 'delete') {
      url += '?' + _querystring2.default.encode(params);
    } else if (configs.method === 'post' || configs.method === 'put') {
      if (configs.useApplicationJson) {
        if (!configs.headers) {
          configs.headers = {};
        }
        if (!configs.headers.Accept) {
          configs.headers.Accept = 'application/json';
        }
        if (!configs.headers['Content-Type']) {
          configs.headers['Content-Type'] = 'application/json';
        }
        configs.body = JSON.stringify(params);
      } else if (configs.useApplicationForm) {
        if (!configs.headers['Content-Type']) {
          configs.headers['Content-Type'] = 'application/x-www-form-urlencoded';
        }
        configs.body = _querystring2.default.encode(params);
      } else {
        configs.body = params;
      }
    }
  }

  return fetch(url, configs).then(handleErrors).then(function (response) {
    return response.json();
  }).then(callback);
}