'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.mediaQuery = mediaQuery;
exports.pageWidth = pageWidth;
exports.pageHeight = pageHeight;

var _core = require('../core');

var _core2 = _interopRequireDefault(_core);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var win = window,
    doc = document;

//Media query
function mediaQuery(media) {
  var ret = false;

  if (win.matchMedia) {
    //If the browser support matchMedia
    ret = win.matchMedia(media).matches;
  } else {
    //For browsers that support matchMedium api such as IE 9 and webkit. Reference by https://github.com/paulirish/matchMedia.js/blob/master/matchMedia.js
    var styleMedia = win.styleMedia || win.media;
    if (styleMedia) {
      ret = styleMedia.matchMedium(media || 'all');
    }
  }

  return ret;
}

//Get current width of page
function pageWidth() {
  return win.innerWidth != null ? win.innerWidth : doc.documentElement && doc.documentElement.clientWidth != null ? doc.documentElement.clientWidth : doc.body != null ? doc.body.clientWidth : null;
}

//Save initial width of page
_core2.default.globalWidth = pageWidth();

//Get current height of page
function pageHeight() {
  return win.innerHeight != null ? win.innerHeight : doc.documentElement && doc.documentElement.clientHeight != null ? doc.documentElement.clientHeight : doc.body != null ? doc.body.clientHeight : null;
}

//Save initial height of page
_core2.default.globalHeight = pageHeight();

_extends(_core2.default, {
  mediaQuery: mediaQuery,
  pageWidth: pageWidth,
  pageHeight: pageHeight
});