﻿export const num = /^\+?[1-9][0-9]*$/;  //大于0的整数
export const numZ = /^\+?[0-9][0-9]*$/; //正整数(包含0)
export const numZ2 = /^-?[0-9][0-9]*$/; //整数(包含0、负数)
export const numF = /^-?([0-9][0-9]*)(\.\d{1,2})?$/; //数字(包含负数、0,最多两位小数)
export const numF2 = /^([0-9][0-9]*)(\.\d{1,2})?$/; //数字(不含负数,最多两位小数)
export const numD = /^-?([0-9][0-9]*)(\.\d{1,10})?$/; //数字(包含负数、0,最多10位小数)
export const numD2 = /^(([0-9]+[\.]?[0-9]+)|[1-9])$/; //数字(不含负数和0,无限位小数)
export const numD3 = /^(([0-9]+[\.]?[0-9]+)|[0-9])$/; //数字(不含负数,无限位小数)
export const num0_100 = /^(?:0|[1-9][0-9]?|100)$/;  //0-100内整数
export const num0_1 = /^[01]$|^0\.\d{1,2}$|^1\.0{1,2}$/;  //0-1之间小数(最多两位),包含0、1
export const post = /^\d{6}$/; //邮编
export const phone = /^(((\()?\d{2,4}(\))?[-(\s)*]){0,2})?(\d{7,8})$/; //固定电话(区号部分为2-4位数字,外面可以加括号,后面可以加斜杠或空格,可重复1-2次;电话号码部分为7-8位)
export const mobile = /^[1][3,5,8][0-9]{9}$/; //手机号
export const email = /^[0-9a-zA-Z]([-.\w]*[0-9a-zA-Z])*@(([0-9a-zA-Z])+([-\w]*[0-9a-zA-Z])*\.)+[a-zA-Z]{2,9}$/; //Email(@前面不能以点为结尾)
export const date = /^\d{4}-\d{2}-\d{2}$/;  //日期是否yyyy-MM-dd格式
export const time = /^\d{2}:\d{2}:\d{2}$/;  //时间是否hh:mm:ss格式
export const datetime = /^\d{4}-\d{2}-\d{2} \d{2}:\d{2}:\d{2}$/;  //日期时间是否yyyy-MM-dd hh:mm:ss格式
export const datetimeO = /^\d{4}-\d{2}-\d{2}( \d{2}:\d{2}:\d{2})?$/;  //是否date或datetime格式
export const pass = /^[0-9a-zA-Z]{6,16}$/;  //密码格式是否由字母和数字组成,长度为6-16位
export const user = /^[a-zA-Z][a-zA-Z0-9_\u4E00-\u9FA5]{3,15}$/;  //用户名格式是否由字母、数字、中文和下划线组成,以字母开头,长度为4-16位
export const ip = /^((25[0-5])|(2[0-4]\d)|(1\d\d)|([1-9]\d)|\d)(\.((25[0-5])|(2[0-4]\d)|(1\d\d)|([1-9]\d)|\d)){3}(:(6553[0-5]|655[0-2]\d|65[0-4]\d{2}|6[0-4]\d{3}|[1-5]\d{4}|[1-9]\d{0,3}))?$/; //IP格式为xxx.xxx.xxx.xxx或xxx.xxx.xxx.xxx:端口号,xxx的值必须是0-255,端口号的值必须是1-65535
export const cardId = /^(\d{18,18}|\d{15,15}|\d{17,17}x)$/i;   //身份证
export const enFirst = /^[a-zA-Z][\s\S]*$/;  //英文开头
export const chFirst = /^[\u4E00-\u9FA5][\s\S]*$/;  //中文开头
export const percent = /^\+?(([1-9]\d?)|(100)|(0))\%$/;  //百分数(0%-100%)